package model

import "time"

type Check struct {
	CheckID    int       `gorm:"column:check_id"`
	UserID     int       `gorm:"column:user_id"`
	CheckDate  time.Time `gorm:"column:check_date"`
	Hospital   int       `gorm:"column:check_hospital"`
	InsertTime time.Time `gorm:"column:insert_time"`
	UpdateTime time.Time `gorm:"column:update_time"`
}

func (Check) TableName() string {
	return "checks"
}

type CheckItem struct {
	CheckItemID int     `gorm:"column:check_item_id"`
	CheckID     int     `gorm:"column:check_id"`
	ItemID      int     `gorm:"column:item_id"`
	ItemValue   float32 `gorm:"column:item_value"`
}

func (CheckItem) TableName() string {
	return "check_items"
}

type Item struct {
	ItemID        int    `gorm:"column:item_id"`
	ItemName      string `gorm:"column:item_name"`
	ItemNormalMin string `gorm:"column:item_normal_min"`
	ItemNormalMax string `gorm:"column:item_normal_max"`
}

func (Item) TableName() string {
	return "items"
}

type UserInput struct {
	Date     string  `json:"date"`
	Hospital int     `json:"checkHospital"`
	Ca125    float32 `json:"ca125Value"`
	Ca199    float32 `json:"ca199Value"`
	Cea      float32 `json:"ceaValue"`
	Ca153    float32 `json:"ca153Value"`
	Ca724    float32 `json:"ca724Value"`
	He4      float32 `json:"he4Value"`
	Rbc      float32 `json:"rbcValue"`
	Hb       float32 `json:"hbValue"`
	Wbc      float32 `json:"wbcValue"`
	Plt      float32 `json:"pltValue"`
	Neut     float32 `json:"neutValue"`
	Weight   float32 `json:"weightValue"`
}
