package hospital

import (
	"health-go/config"
	"health-go/model"
)

func Modify(hospital model.Hospital) (bool, error) {
	result := config.DB.
		Table("hospital").
		Where("hospital_id = ?", hospital.HospitalID).
		Updates(map[string]interface{}{
			"hospital_name": hospital.HospitalName,
			"address":       hospital.Address,
		})
	if result.Error != nil {
		return false, result.Error
	}
	return true, nil
}

func FetchAll() ([]model.Hospital, error) {
	var hospitals []model.Hospital
	result := config.DB.Table("hospital").Find(&hospitals)
	if result.Error != nil {
		return nil, result.Error
	}
	return hospitals, nil
}

func Add(hospital model.Hospital) (bool, error) {
	result := config.DB.Table("hospital").Create(&hospital)
	if result.Error != nil {
		return false, result.Error
	}
	return true, nil
}

func Delete(hospitalID int) (bool, error) {
	result := config.DB.Table("hospital").Where("hospital_id = ?", hospitalID).Delete(&model.Hospital{})
	if result.Error != nil {
		return false, result.Error
	}
	return true, nil
}
